#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<malloc.h>
//ά
#define N 9
//Ϊ10^6
#define MAXNUM 1000000
//ֵΪ10^8Ԫؾֵֵжϵɢ
#define X_MAX 100000000
//
double Inftynum(double *x1,double *x2, int n){
    double max=0;
    int i;
    for(i=0;i<n;i++){
        if(max<fabs(x1[i]-x2[i]))
            max=fabs(x1[i]-x2[i]);
    }
    return max;
}
//Gauss-Seidel
void GS(double **a, double *b, double *X0, int n, double epsilon, int maxn){
    double *X1,*X2;
    double s;
    X1=(double *)malloc(n*sizeof(double));
    X2=(double *)malloc(n*sizeof(double));
    int num,i,j;
    for(i=0;i<n;i++)
        X2[i]=X0[i];
    for(num=1;num<maxn;num++){
        for(i=0;i<n;i++)
            X1[i]=X2[i];
        for(i=0;i<n;i++){
            s=0;
            for(j=0;j<n;j++)
                s+=a[i][j] * X2[j];
            X2[i]=(b[i]-s+a[i][i]*X2[i])/a[i][i];
        }
        if(Inftynum(X1,X2,n)<epsilon)
            break;
    }
    printf("Gauss-SeidelΪ%d\nĽΪ\n",num);
    for(i=0;i<n;i++){
        printf("x%d=%.15E\n",(i+1),X2[i]);
    }
    //ͷڴ
    free(X1);
    free(X2);
}
//SORĵΪָߵֵɢжΪ
int SOR(double **a,double *b, double *X0, int n, double epsilon, int maxn, double omega){
    double *X1,*X2;
    double s;
    X1=(double *)malloc(n*sizeof(double));
    X2=(double *)malloc(n*sizeof(double));
    //flagǵǷɢ
    int num,i,j,flag=0;
    for(i=0;i<n;i++)
        X2[i]=X0[i];
    for(num=1;num<maxn;num++){
        for(i=0;i<n;i++)
            X1[i]=X2[i];
        for(i=0;i<n;i++){
            s=0;
            for(j=0;j<n;j++)
                s+=a[i][j] * X2[j];
            X2[i]=(1-omega)*X1[i]+omega*(b[i]-s+a[i][i]*X2[i])/a[i][i];
            if(fabs(X2[i])>X_MAX){
                flag=1;
                break;
            }
        }
        if(Inftynum(X1,X2,n)<epsilon || flag==1)
            break;
    }
    printf("\n");
    if(num<maxn && flag==0){
        printf("omega=%.2lfΪ%d\nĽΪ\n",omega,num);
        for(i=0;i<n;i++){
            printf("x%d=%.15E\n",(i+1),X2[i]);
        }
    }
    else{
        printf("omega=%.2lf\n",omega);
        //ͷڴ
        free(X1);
        free(X2);
        return maxn;
    }
    //ͷڴ
    free(X1);
    free(X2);
    return num;
}
//ѰɳӶӦi
int FINDM(int *times,int n){
    int min=times[1],min_i=1,i;
    for(i=2;i<n;i++)
        if(min>times[i]){
            min=times[i];
            min_i=i;
        }
    return min_i;
}

int main(void){
    //
    double a[N][N] = {                     \
    { 31,-13,  0,  0,  0,-10,  0,  0,  0}, \
    {-13, 35, -9,  0,-11,  0,  0,  0,  0}, \
    {  0, -9, 31,-10,  0,  0,  0,  0,  0}, \
    {  0,  0,-10, 79,-30,  0,  0,  0, -9}, \
    {  0,  0,  0,-30, 57, -7,  0, -5,  0}, \
    {  0,  0,  0,  0, -7, 47,-30,  0,  0}, \
    {  0,  0,  0,  0,  0,-30, 41,  0,  0}, \
    {  0,  0,  0,  0, -5,  0,  0, 27, -2}, \
    {  0,  0,  0, -9,  0,  0,  0, -2, 29}  \
    };
    double b[N]={-15, 27, -23, 0, -20, 12, -7, 7, 10};
    double epsilon=1E-7;
    int i,j;
    double **A,*B,*X0;
    //̬ڴ淽Ϊͨó򴫲
    A=(double **)malloc(N*sizeof(double *));
    for(i=0;i<N;i++)
        A[i]=(double *)malloc(N*sizeof(double));
    B=(double *)malloc(N*sizeof(double));
    for(i=0;i<N;i++){
        for(j=0;j<N;j++)
            A[i][j]=a[i][j];
        B[i]=b[i];
    }
    //õʼ
    X0=(double *)malloc(N*sizeof(double));
    for(i=0;i<N;i++)
        X0[i]=0;
    //Gauss-Seidel
    GS(A,B,X0,N,epsilon,MAXNUM);
    int times[100]={0};
    printf("\nSOR\n");
    for(i=1;i<100;i++)
        times[i]=SOR(A,B,X0,N,epsilon,MAXNUM,(double)i/50);
    printf("\nɳomega=%d/50=%.2lf\n",FINDM(times,100),(double)FINDM(times,100)/50);
    //ͷڴ
    for(i=0;i<N;i++)
        free(A[i]);
    free(A);
    free(B);
    free(X0);
    system("pause");
    return 0;
}
